/*
    OpenGUI - Drawing & Windowing library

    Copyright (C) 1996,2000  Marian Krivos

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    nezmar@internet.alcatel.sk
*/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "config.h"
#include "fastgl.h"
#include "widgets.h"
#include "_fastgl.h"
#include "drivers.h"

#ifdef __WATCOMC__
#define	random rand
#define	srandom srand
#endif

extern int rnd(int);
#ifndef _WIN32
#define rnd(a) (random()%(a+1))  // macro for randomize fnc
#else
#define rnd(a) (random(a))  // macro for randomize fnc
#endif
int a, b;
char s[80];

Window *w1, *w2;
ButtonGroup *grp;

int cas()
{
	static int a = 0, b;

	b = a;
	return ((a = clock()) - b);
}

int test3()
{
	int i, j, f, c,



		w=w1->GetWW(),
		h=w1->GetHW();

	set_ppop(0);
	f = clock();
	for (j = 0; j < 6000; j++)
	{
		w1->WindowFillEllipse(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(50), rnd(255));
		w1->WindowDrawEllipse(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(50), rnd(255));
		w1->WindowText(rnd(w1->GetW()), rnd(w1->GetH()), "Hello", rnd(255), rnd(255));
		set_fcolor(rnd(255));
		w1->WindowBox(rnd(w1->GetW()), rnd(w1->GetH()), 40, 30);
//		cApp->Yield();
	}
	set_ppop(0);
	draw_point(200,200);
	for (j = 0; j < h; j++)
	{
		for (i = 0; i < w; i++)
		{
			w1->WindowPixel(i, j, i + j);
		}
	}

  int polygon[10][2];
  for (j=0;j<100;j++)
  {
    int npoints = rand() % 7 + 3;
    for (i=0; i<npoints; i++) {
      polygon[i][0] = rand() % w;
      polygon[i][1] = rand() % h;
    }
//    FGPixel color = CreateColor(rand() % 256, rand() % 256, rand() % 256, 16);
    w1->WindowFillPolygon(npoints, polygon, rand());
  }
//	printf("cas pred printf=%d\n", clock());
	set_colors(CBLUE,CWHITE);
	for (j = 0; j < 6000; j++)
	{
		c=rand()&127;
		if (c=='\n') c=12;
		w1->printf("%c", c);
	}
//	printf("cas po printf=%d\n", clock());

	for (j = 0; j < 600; j++)
	{
		set_fcolor(rand()%0xffffff);
		w1->WindowLine(rnd(w1->GetWW()+100), rnd(w1->GetHW()), rnd(300), rnd(300), rnd(0xffffff));
	}
	graph_change_mode(1024,768);
	return clock() - f;
}

void test(CallBack)
{
	Window *w = Window::GetCurrent();

	cas();
	set_ppop(_GSET);
	a = test3();
	sprintf(s, "Graph WinMark - %d", a);
	w->WindowText(20, 180, s);
#ifndef __QNX__
	sprintf(s, "MMX Extension : %s", __fgl_mmx ? "Yes" : "No");
	w->WindowText(20, 200, s,CWHITE);
#endif
	set_ppop(_GSET);
}

void myexit(CallBack)
{
  App::AppDone();
}

void select_file(char *s, FileDialog *)
{
	Bitmap *b = new Bitmap(s);
	w1->WindowPutBitmap(0,0,0,0,800,600,b);
}

extern void AlphaBlit(FGPixel *dst_data, FGPixel *src_data, int len, int alfa);

extern char gps[];

int app(GuiEvent *e)
{
	if (e->GetType() == KEYEVENT)
	{
//		w1->printf("%s\n",gps);
	}
	return 1;
}

class TForm : public App
{
		void OnKeyPress(int key)
		{
			set_colors(0,255);
			gprintf(100,100,"KEYEVENT %4d            ",key);
		}
		void OnMouseMove(int x, int y)
		{
			set_colors(0,255);
			gprintf(100,100,"MOVEEVENT %4d %4d",x,y);
		}
		void OnClick(int x, int y)
		{
			set_colors(0,255);
			gprintf(100,100,"CLICKLEFTEVENT %4d %4d",x,y);
		}
		void OnContextPopup(int x, int y)
		{
			set_colors(0,255);
			gprintf(100,100,"CLICKRIGHTEVENT %4d %4d",x,y);
		}
		void OnClose(void)
		{
			set_colors(0,255);
			gprintf(100,100,"QUITEVENT");
		}
		void OnPaint(void)
		{
			set_colors(0,255);
			gprintf(100,100,"PAINTEVENT");
		}
		void OnInit(void)
		{
			set_colors(0,255);
			gprintf(100,100,"INITEVENT");
		}
		void OnCursorOut(int smer)
		{
			set_colors(0,255);
			gprintf(100,100,"CURSOROUTEVENT %d", smer);
		}
		void OnStartDrag(int smer, int x, int y)
		{
			set_colors(0,255);
			gprintf(100,100,"DRAGEVENT %d - [%04d:%04d]", smer,x,y);
		}
		void OnEndDrag(int smer, int x, int y, int w, int h)
		{
			set_colors(0,255);
			gprintf(100,100,"ENDDRAGEVENT %d - [%04d:%04d-%04d:%04d]", smer,x,y,w,h);
		}
	public:
		TForm(int argc, char **argv)
			: App(3,argc,argv,0,APP_ALL)
		{
		}
};

class TWindow : public Window
{
	public:
		TWindow() : Window(0,0,0,200,120,"Okno")
		{
		}
		virtual void OnMouseMove(int,int)
		{
			Puk();
		}
};

//extern "C" const unsigned int _12x24[];

int main(int argc, char **argv)
{
	TForm MyApp(argc, argv);
	TWindow MyWnd;
	Control *eb;
//	int ff = register_font((unsigned char*)_12x24, 12, 24, 256, 0);
//	set_font(ff);
	(void)new Window(&w1, 20, 20, X_width-40, Y_width-40, "Test Window", GuiHwnd(NULL), CBLACK, CGRAY1, WFRAMED|WMINIMIZE);
	(void)new Window(&w2, X_width-440, Y_width-340, 400, 300, "Main Window", 0, 7, CWHITED, 
	WSIZEABLE | WMENU | WTITLED |WFRAMED|WNOICON|WSTATUSBAR|WMINIMIZE);
//	Bitmap icon("mysha.pcx");

//	App::GetRootWindow()->WindowPutBitmap(0, 0, 0,0,X_width, Y_width,&icon);

	w2->AddBaseMenu("File ", 'F');
	w2->AddBaseMenu("Edit ", 'E');
	eb = w2->AddPushButton(320, 10, 60, 24, "Test", 'T', test);
	eb = w2->AddPushButton(320, 40, 60, 24, "Quit", 'Q', myexit);

//	set_font(ff);
	sprintf(s, " !@12 Resolution %dx%dx%d", X_width, Y_width, get_colordepth());
	w2->WindowText(20, 50, s);
	w2->WindowStatusBar(0, "asd");

 	w1->WindowFillCircle(100,100,50,CBLACK+6);
	int mz[][2]={{62,186},{135,150},{221,197},{377,125},{231,25},{150,85},{10,18},{62,186}};
	set_ppop(_GXOR);
	w1->WindowFillPolygon(8,mz,CRED);
	set_ppop(_GSET);
	w1->WindowDrawPolygon(8,mz,CRED);
	w1->WindowPatternLine(0, 0, 300, 0, &PatternDot);
	w1->WindowPatternLine(0, 20, 300, 20, &PatternSlashDot);
	w1->WindowPatternLine(0, 30, 300, 30, &PatternSlashDotSlash);
	w1->WindowPatternLine(0, 50, 300, 50, &PatternSlash);
	FGPixel *bm = (FGPixel *)malloc(areasize(X_width,Y_width));
	FGmemset(bm, (FGPixel)0x0300, (X_width*Y_width));
	int rrr=clock();
	AlphaBlit(bm, bm, (X_width*Y_width), 120);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
//	printf("Blit = %d\n", clock()-rrr);
//	free(bm);
/*
	rrr=clock();
	set_ppop(0);
	for(int g=0;g<200;g++)
	{
		set_fcolor(g);
//		fill_box(0, 0, 800, 600);
	}
	for(int g=0;g<1000;g++)
	{
		set_fcolor(g);
		draw_line(0, 0, 800, g);
		draw_line(799, 0, 0, g);
	}
//	printf("Hw Blit = %d\n", clock()-rrr);
*/
	set_fcolor(CRED);
	draw_line(0,0,800,600);
	MyApp.SetTimerProc(0,10);
	MyApp.Run(app);
//	delay(2000);
//	get_key();
	return 0;
}

