#
# make OpenGUI library for MS_DOS DJGPP final - common part
#

ifdef PNGSUPPORT
OPTIONS2	= -DFG_PNG
endif

ifdef JPGSUPPORT
OPTIONS3	= -DFG_JPEG
endif

CFLAGS  =   -mcpu=i586 -fno-exceptions -gcoff -c -O2 $(COLORDEPTH) $(OPTIONS2) $(OPTIONS3) -I../include
CC	=  gcc
HDRS    =   base.h  _fastgl.h config.h
OBJS	=   engine.o fastgl.o base.o resource.o widgets.o user.o detect.o editor.o bitmap.o timer.o drivers.o msdos.o fgstring.o listbox.o
INCDIR	=  $(subst /,\,$(DJDIR)/include/fastgl)


default: $(STARGET) file2asm
	del $(subst /,\,$(DJDIR)/include/fastgl.h)
	del $(subst /,\,$(DJDIR)/include/base.h)
	del $(subst /,\,$(DJDIR)/include/widgets.h)

	mkdir $(INCDIR)
	copy $(STARGET) $(subst /,\,$(DJDIR)/lib)
	copy base.h $(INCDIR)
	copy fastgl.h $(INCDIR)
	copy widgets.h $(INCDIR)
	copy fglist.h $(INCDIR)
	copy fgstring.h $(INCDIR)
	copy listbox.h $(INCDIR)
	copy file2asm.exe $(subst /,\,$(DJDIR)/bin)
	@echo All done.
	@echo 
	@echo To use OpenGUI, #include fastgl/fastgl.h
	@echo 
	@echo Example command line: gcc foobar.c -o foobar.exe -lfgl
	@echo Enjoy!
	
clean:
	del  *.a	
	del  *.o
	del  *.lib
	del  *.obj
	del  *.exe
	del  *.err
		
$(STARGET): $(OBJS)
	ar   rcs $(STARGET) $(OBJS)

file2asm: file2asm.cpp
	gcc  -o file2asm.exe file2asm.cpp
	strip file2asm.exe
	
fastgl.o:  $(HDRS)     fastgl.cpp fastgl.h
	$(CC)  $(CFLAGS)  fastgl.cpp

bitmap.o:  $(HDRS)     bitmap.cpp fastgl.h
	$(CC)  $(CFLAGS)  bitmap.cpp

widgets.o:  $(HDRS)     widgets.cpp widgets.h fastgl.h
	$(CC)  $(CFLAGS)  widgets.cpp

editor.o:  $(HDRS)     editor.cpp widgets.h fastgl.h
	$(CC)  $(CFLAGS)  editor.cpp

base.o:  $(HDRS)   base.cpp drivers.h base.h
	$(CC)  $(CFLAGS)  base.cpp

detect.o:  $(HDRS)   detect.c
	$(CC)  $(CFLAGS)  detect.c

user.o:  $(HDRS)   user.cpp fastgl.h
	$(CC)  $(CFLAGS)  user.cpp

drivers.o:  $(HDRS)   drivers.cpp drivers.h
	$(CC)  $(CFLAGS)  drivers.cpp

msdos.o:  $(HDRS)   msdos.cpp msdos.h
	$(CC)  $(CFLAGS)  msdos.cpp

listbox.o:  $(HDRS)   listbox.cpp listbox.h fglist.h
	$(CC)  $(CFLAGS)  listbox.cpp

fgstring.o:  $(HDRS)   fgstring.cpp fgstring.h
	$(CC)  $(CFLAGS)  fgstring.cpp

timer.o:  $(HDRS)   timer.cpp fastgl.h
	$(CC)  $(CFLAGS)  timer.cpp

resource.o:  $(HDRS)   resource.cpp
	$(CC)  $(CFLAGS)  resource.cpp

engine.o:engine.asm
	nasm -f coff engine.asm


