/*
	An virtual parent for FGListBox that implement all stuff
*/

#ifndef __LISTBOX__
#define __LISTBOX__

#include "fglist.h"

//#pragma interface

class _listbox : public Slider
{
	protected:
		int		cursor; 			// visible cursor
		int		slider;			 	// for position of slider
		int		drop_down;			// size in visible lines
		int 	color_bg0, color_bg1, color_fg0, color_fg1; // colors
		int 	x, y,				// top left of widgets
				curr,				// current item or -1
				count,				// 0 ...
				fpol,				// first visible
				line,				// Y-position of line
				onew, oneh; 		// width x height of one item

		void	corecture(void);
		virtual void draw(void); // for slider
		virtual void DrawItem(int , int , int , int ) {}
		void 	Cursor(int);
		// try move cursor at new index and adjust all variables to new values
		int		AdjustCursor(int item);
		int		Enabled(void) { if (curr<0 || count<=0) return 0; return 1;}
		static  void	lbCall(Control *T);
	public:
		_listbox(int xs, int ys, int w, int h, int DropDown, Window *wind);
		void	SetColors(int a, int b, int c, int d)
		{
			color_bg0 = a; color_fg1 = c;
			color_bg1 = b; color_fg0 = d;
		}
		void 	Draw(int i);	// for listbox
		void 	ShowCursor(void);
		void 	HideCursor(void);
		void 	Up(void);
		void 	Down(void);
		void 	Begin(void);
		void 	End(void);
		void 	SetSize(int);
		int 	GetSize(void) const { return count; };
		void 	SetIndex(int);
		int 	GetIndex(void) const { return curr; };
		void 	SetIndexRel(int);
		int  	Test(int, int);
		int		DoListBox(int key);
};

/*
*/
class FGListBox : public _listbox
{
		struct id_string
		{
			char str[32];
			id_string()
			{
				*str=0;
			}
			id_string(char *s)
			{
				strncpy(str,s,31);
				str[31]=0;
			}
		};
		
		typedef FGList<id_string>::iterator Iter;

		FGList<id_string>	items;
		int					update;
		
		virtual void DrawItem(int x, int y, int index, int flag);
		void (*show)(int flag, Window *wnd,int x,int y,void *ptr, int index);
	public:
		FGListBox(int xs, int ys, int w, int h, int DropDown, Window *wind, void (*show_cb)(int , Window *,int,int,void *, int)=0)
		: _listbox(xs,ys,w,h,DropDown,wind)
		{
			update = 0;
			show = show_cb;
		}
		void DisableUpdate(void) { update = 0; }
		void Update(void)
		{
			update = 1;
			Draw(1);
		}
		void insert(char *s)
		{
			items.push_back(s);
			count++;
			if (update) Draw(0);
		}
		void insert(int i, char *s)
		{
			items.insert(items.begin()+i,s);
			count++;
			if (update) Draw(0);
		}
		void erase(int i)
		{
			items.erase(items.begin()+i);
			count--;
			if (update) Draw(0);
		}
		// set null state
		void clear(void)
		{
			count = fpol = line = curr = 0;
			Draw(0);
			update = 0;
			items.clear();
		}
		char *item(int i)
		{
		    Iter ti = items.begin();
		    return ti[i].str;
		}
		void change(int i, char *s)
		{
		    Iter ti = items.begin();
		    strncpy(ti[i].str, s, 31);
		    ti[i].str[31]=0;
		}
};
#endif
