/*
   priklad aplikacie na pouzitie modulu pre touch screen
*/

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include "pmntdrv.h"

int main(void)
{
  int dev_fd;
  pmnt_event_t pmntev;
  pmnt_init_t pmntinit;

// otvorenie suboru zariadenia.Subor sa vytvori skriptom dev_ld
  if ((dev_fd=open("/dev/pmntdrv",O_RDWR))<0)
  {
    perror("dev_open");
    return EXIT_FAILURE;
  }

// musi sa pouzit ako prve.Modul nastavuje touch screen na maximalne rozlisenie
  pmntinit.scr_width=80;
  pmntinit.scr_height=25;
  pmntinit.scr_left=3;
  pmntinit.scr_top=3;
  pmntinit.scr_right=79;
  pmntinit.scr_bottom=24;
  ioctl(dev_fd,PMNTIO_INIT,&pmntinit);

  fcntl(0,F_SETFL,fcntl(0,F_GETFL)|O_NONBLOCK);
  while (getchar()!='q')
  {
// precitanie,ci doslo k nejakej udalosti.Modul neblokuje citanie,ak nedoslo k
// udalosti,ale nastavi event na PEN_NOTHING
    ioctl(dev_fd,PMNTIO_GETEVENT,&pmntev);
    switch (pmntev.event)
    {
      case PEN_DOWN:
        printf("pen down at x=%i,y=%i\n",pmntev.wherex,pmntev.wherey);
        break;
      case PEN_MOVE:
        printf("pen moved to x=%i,y=%i\n",pmntev.wherex,pmntev.wherey);
        break;
      case PEN_UP:
        printf("pen up at x=%i,y=%i\n",pmntev.wherex,pmntev.wherey);
        break;
    }
  }
  fcntl(0,F_SETFL,fcntl(0,F_GETFL)&(~O_NONBLOCK));

  close(dev_fd);
  return EXIT_SUCCESS;
}





        
