#ifndef PMNTDRV_H
#define PMNTDRV_H

#define PEN_NOTHING -1 // ziadna udalost
#define PEN_DOWN 0 // pero pritlacene na suradniciach wherex,wherey
#define PEN_MOVE 1 // pero posunute na suradnice wherex,wherey bez zdvihnutia
#define PEN_UP 2 // pero zdvihnute na suradniciach wherex,wherey

// struktura,ktoru modul predava informacie o stave pera
typedef struct
{
  int event;
  int wherex;
  int wherey;
} pmnt_event_t;

// struktura pre inicializaciu
typedef struct
{
  int scr_width;  // sirka obrazovky 0 - 0x3FC
  int scr_height; // vyska obrazovky 0 - 0x3FC
  int scr_left;   // x suradnica laveho horneho rohu 03-FF
  int scr_top;    // y suradnica laveho horneho rohu 03-FF
  int scr_right;  // x suradnica praveho dolneho rohu 03-FF
  int scr_bottom;    // y suradnica praveho dolneho rohu 03-FF
} pmnt_init_t;

#include <linux/ioctl.h>

// pouzitie vid penapp.c
#define PMNTIO_ID 0xbb
#define PMNTIO_INIT _IOWR(PMNTIO_ID,0,pmnt_init_t*)
#define PMNTIO_GETEVENT _IOWR(PMNTIO_ID,1,pmnt_event_t*)  

#endif // PMNTDRV_H