#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <vga.h>
#include <vgagl.h>
#include "pmntdrv.h"

#define RH 10
#define RW 10

static void light(int x,int y,int on)
{
  int sx=x/RW*RW;
  int sy=y/RH*RH;
  int color=on?14:0;

  gl_fillbox(sx+1,sy+1,RW-1,RH-1,color);
}

static void touch(int x,int y)
{
  static int prevx=0;
  static int prevy=0;

  light(prevx,prevy,0);
  prevx=x;
  prevy=y;
  light(prevx,prevy,1);
}

int main(void)
{
  int dev_fd;
  pmnt_event_t pmntev;
  pmnt_init_t pmntinit;
  int i;
  FILE *f;

  if (vga_setmode(11))
  {
    printf("VGA init error\n");
    return EXIT_FAILURE;
  }
  gl_setcontextvga(11);

// otvorenie suboru zariadenia.Subor sa vytvori skriptom dev_ld
  if ((dev_fd=open("/dev/pmntdrv",O_RDWR))<0)
  {
    i=errno;
    vga_setmode(TEXT);
    errno=i;
    perror("open");
    return EXIT_FAILURE;
  }
  pmntinit.scr_width=800;
  pmntinit.scr_height=600;
  pmntinit.scr_left=15;
  pmntinit.scr_top=15;
  pmntinit.scr_right=0xf0;
  pmntinit.scr_bottom=0xf0;
  ioctl(dev_fd,PMNTIO_INIT,&pmntinit);

  for (i=0;i<vga_getydim();i+=RH)
    vga_drawline(0,i,vga_getxdim()-1,i);
  for (i=0;i<vga_getxdim();i+=RW)
    vga_drawline(i,0,i,vga_getydim()-1);

  fcntl(0,F_SETFL,fcntl(0,F_GETFL)|O_NONBLOCK);
  while (getchar()!='q')
  {
    ioctl(dev_fd,PMNTIO_GETEVENT,&pmntev);
    switch (pmntev.event)
    {
      case PEN_DOWN:
        touch(pmntev.wherex,pmntev.wherey);
        break;
      case PEN_MOVE:
        touch(pmntev.wherex,pmntev.wherey);
        break;
      case PEN_UP:
//        light(pmntev.wherex,pmntev.wherey,0);
        break;
    }
  }
  fcntl(0,F_SETFL,fcntl(0,F_GETFL)&(~O_NONBLOCK));

  vga_setmode(TEXT);
  close(dev_fd);

  return EXIT_SUCCESS;
}








  
