#include "config.h"
#include "fastgl.h"
#include "_fastgl.h"

#include "drivers.h"
#include "qnx.h"

int FGQNXDriver::set_mode(int ww, int hh)
{
   	req_w = ww;
    req_h = hh;
	
	FGDriver::set_mode(w,h);
   	mode_num = find(req_w, req_h);
    if (mode_num==-1)
	{
       	printf("Mode %dx%d not found!\n", ww, hh);
        return 0;
    }
	if (verbose) printf("\tmode \"%dx%dx%d\" as VESA:0x%x passed ... ", modelist[mode_num].w, modelist[mode_num].h, bpp*8, modelist[mode_num].mode);
	videobase = 0;	// always NULL as segment start
	islinear = 0;
	int value = modelist[mode_num].mode;
	if (_setvideomode(value) ==	0) return 0; //set properly mode
	if (verbose) printf("O.K.\n");
	virt_w = req_w;
	virt_h = req_h;
	subname = strdup(drv_name[driver]);
	synch = 0;
	return postinit();
}

int FGQNXDriver::get_event(int& type, int& key, int& x, int& y, int& buttons)
{
	GuiEvent e;
	if (Creceive(user_pid,&e,sizeof(GuiEvent)) !=	-1)
	{
		x = e.GetX();
		y = e.GetY();
		type = e.GetType();
		buttons = e.GetButtons();
		key = e.GetKey();
		Reply(user_pid,&e,sizeof(GuiEvent));
		return TRUE;
	}
	return FALSE;
}
