unsigned seg_overlay(void);
unsigned qnx_segment_overlay_flags(void);
#pragma aux seg_overlay "_*";
#pragma aux qnx_segment_overlay_flags "*_";

class FGQNXDriver : public FGDriver
{
        int			driver;
		unsigned	basesegment; // z VESA info
		pid_t		user_pid;

		int		tty_fd;
		int		tty_no;
		int		visible;
		int		oldx, oldy, but;
		int		mousex, mousey, xmax, ymax;
		FGPixel *sbak;
	protected:
	public:
		virtual int	available(void)
		{
			if (geteuid())
			{
				printf("this program must be suid root!\a\n");
				return 0;
			}
			return 1;
		}
		FGQNXDriver(void) : FGDriver("QNXsvga")
        {
            driver = ::driver;
			tty_fd = -1;
			but = 0;
			tty_no = -1;
			sbak = 0;
        }
		~FGQNXDriver()
		{
			kill(user_pid, SIGKILL);
			sync();
		}
		virtual int text_mode(void)
		{
			_setvideomode(3);
			return TRUE;
		}
		virtual int	link(void)
		{
			if (driver < 0)
				driver = 0;			// no detect, force VESA
			else if	(driver	== 0)
				driver = detect_video(verbose);	// detect card
			::driver = driver;
			// hack!!!
			videobasesegment = 0xa000U;
			islinear = 0;
			granularity = 64;
        	return 1;
        }
		virtual void get_all_modes(vmode *p)
		{
			p->mode = 0x13;
			p->refresh = 0;
			p->flag = 0;
			p->w = 320;
			p->h = 200;
			p++;
			
			p->mode = 0x101;
			p->refresh = 0;
			p->flag = 0;
			p->w = 640;
			p->h = 480;
			p++;
			
			p->mode = 0x103;
			p->refresh = 0;
			p->flag = 0;
			p->w = 800;
			p->h = 600;
			p++;
			
			p->mode = 0x105;
			p->refresh = 0;
			p->flag = 0;
			p->w = 1024;
			p->h = 768;
			p++;
			
			p->mode = 0x107;
			p->refresh = 0;
			p->flag = 0;
			p->w = 1280;
			p->h = 1024;
			p++;
			
			p->mode = 0x120;
			p->refresh = 0;
			p->flag = 0;
			p->w = 1600;
			p->h = 1200;
			p++;
			
			total_modes = 6;
		}
		virtual int set_mode(int ww, int hh);
		virtual int set_mouse(void)
		{
			mouse_string = "QNX_INPUT_SERVER";
			return ismouse = 1;
		}
		virtual void reset_mouse(void)
		{
			mouseflag = -1;
			ismouse = 0;
		}
		virtual int set_keyboard(void)
		{
			iskeyboard	= 1;
			user_pid = spawnlp(P_NOWAIT, "userevent", "userevent", itoa(w, " g      ",	10), itoa(h, "  w    ", 10), "1", 0);
			if (user_pid ==	-1)	
			{
			    perror("can't spawn 'userevent' server!");
				return 0;
			}
			return TRUE;
		}
		virtual void reset_keyboard(void)
		{
			iskeyboard = 0;
		}
		virtual int get_event(int& type, int& key, int& x, int& y, int& buttons);
};
