# make OpenGUI library for MS_DOS Watcom C++ - common makefile part

!ifdef PNGSUPPORT
OPTIONS2	= -DFG_PNG
!endif

!ifdef JPGSUPPORT
OPTIONS3	= -DFG_JPEG
!endif

CFLAGS  = -d2 -bt=dos -zq -ms -5s -oneat -I..\include $(COLORDEPTH) $(OPTIONS3) $(OPTIONS2)
HDRS    =   base.h _fastgl.h config.h
INCDIR  = $(%WATCOM)\h\fastgl

default : $(STARGET)
	
$(STARGET) : engine.obj fastgl.obj widgets.obj base.obj detect.obj resource.obj user.obj editor.obj bitmap.obj drivers.obj msdos.obj fgstring.obj listbox.obj
	wlib -b -n -q $(STARGET) fastgl engine base detect resource user widgets editor bitmap drivers msdos fgstring listbox
	mkdir $(INCDIR)
	del $(%WATCOM)\h\fastgl.h
	del $(%WATCOM)\h\base.h
	del $(%WATCOM)\h\widgets.h
	copy fastgl.h $(INCDIR)
	copy base.h $(INCDIR)
	copy widgets.h $(INCDIR)
	copy listbox.h $(INCDIR)
	copy fgstring.h $(INCDIR)
	copy fglist.h $(INCDIR)
	copy callback.h $(INCDIR)
	copy $(STARGET) $(%WATCOM)\lib386\dos

clean:
	- del *.obj
	- del *.lib
	- del *.err
	- del *.exe

fastgl.obj:  $(HDRS)     fastgl.cpp fastgl.h
	wpp386  $(CFLAGS)  fastgl.cpp

bitmap.obj:  $(HDRS)     bitmap.cpp fastgl.h
	wpp386  $(CFLAGS)  bitmap.cpp

widgets.obj:  $(HDRS)     widgets.cpp fastgl.h widgets.h
	wpp386  $(CFLAGS)  widgets.cpp

editor.obj:  $(HDRS)     editor.cpp fastgl.h widgets.h
	wpp386  $(CFLAGS)  editor.cpp

base.obj:  $(HDRS)   base.cpp drivers.h base.h
	wpp386  $(CFLAGS)  base.cpp

detect.obj:  $(HDRS)   detect.c
	wpp386  $(CFLAGS)  detect.c

resource.obj:  $(HDRS)   resource.cpp
	wpp386  $(CFLAGS)  resource.cpp

engine.obj: engine.asm
	nasm  -f obj engine.asm

user.obj:  $(HDRS)   user.cpp
	wpp386  $(CFLAGS)  user.cpp

drivers.obj:  $(HDRS)   drivers.cpp drivers.h base.h
	wpp386  $(CFLAGS)  drivers.cpp

msdos.obj:  $(HDRS)   msdos.cpp msdos.h
	wpp386  $(CFLAGS)  msdos.cpp

fgstring.obj:  $(HDRS)   fgstring.cpp fgstring.h
	wpp386  $(CFLAGS)  fgstring.cpp

listbox.obj:  $(HDRS)   listbox.cpp listbox.h
	wpp386  $(CFLAGS)  listbox.cpp

